import { jsx, Fragment } from 'react/jsx-runtime';
import React, { createContext, useContext, useRef, useState, useCallback, useEffect, useMemo, forwardRef, useImperativeHandle, Component as Component$1 } from 'react';
import { useServerSDK } from '@projectproxima/plugin-sdk';
import axios from 'axios';
import { noop } from 'lodash';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    if (typeof b !== "function" && b !== null)
        throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

function __read(o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
}

var PluginGlobalConfigContext = createContext({
    remoteComponentGetDependencies: noop,
    pluginErrorBoundary: function () { return React.createElement("插件加载错误"); },
    remoteComponentErrorBoundary: RemoteComponentErrorBoundary,
    globalInitProps: {},
    axiosInstance: axios.create({}),
    pluginLoadingWrapper: function (loadingStatus, moduleKey, children) {
        // eslint-disable-next-line react/no-children-prop
        return React.createElement(React.Fragment, {
            children: loadingStatus ? children : null,
        });
    },
});

var usePluginGlobalConfig = function () {
    return useContext(PluginGlobalConfigContext);
};

var defaultStyle = {
    border: "none",
    Visibility: "visible",
    width: "100%",
    height: "100%",
};
var CustomIframe = function (props) {
    var frameRef = useRef(null);
    var _a = __read(useState(true), 2), loading = _a[0], setLoading = _a[1];
    var _b = __read(useState({
        error: true,
        reason: null,
    }), 2), serverStatus = _b[0], setServerStatus = _b[1];
    var server = useServerSDK();
    var _c = usePluginGlobalConfig(), PluginErrorBoundary = _c.pluginErrorBoundary, PluginLoadingWrapper = _c.pluginLoadingWrapper, axios = _c.axiosInstance;
    var frameProps = props.frameProps, frameURL = props.frameURL, iframeStyle = props.iframeStyle, _d = props.iframeClass, iframeClass = _d === void 0 ? "" : _d, moduleKey = props.moduleKey;
    var startLoadPlugin = useCallback(function () { return __awaiter(void 0, void 0, void 0, function () {
        var e_1, status_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setLoading(true);
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, axios.get(frameURL)];
                case 2:
                    _a.sent();
                    setServerStatus({
                        error: false,
                        reason: null,
                    });
                    return [3 /*break*/, 4];
                case 3:
                    e_1 = _a.sent();
                    if (!e_1.response) {
                        setServerStatus({
                            error: true,
                            reason: "NONE",
                        });
                    }
                    else {
                        status_1 = e_1.response.status;
                        setServerStatus({
                            error: true,
                            reason: status_1,
                        });
                    }
                    setLoading(false);
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    }); }, [frameURL]);
    // 用于同一个页面切换插件时，loading初始化
    useEffect(function () {
        startLoadPlugin();
    }, [startLoadPlugin]);
    var onLoad = function () {
        var frame = frameProps.frame, context = frameProps.context;
        server
            .register({
            type: "iframe",
            module: props.moduleKey,
            instance: frameRef.current.contentWindow,
            frame: frame,
            context: context,
        })
            .then(function () {
            setLoading(false);
        })
            .catch(function (e) {
            setServerStatus({
                error: true,
                reason: "NONE",
            });
            setLoading(false);
            throw e;
        });
    };
    var handleRetry = useCallback(function () {
        startLoadPlugin();
    }, [startLoadPlugin]);
    var children = useMemo(function () {
        return !serverStatus.error ? (jsx("iframe", { ref: frameRef, className: iframeClass, style: __assign(__assign({}, iframeStyle), defaultStyle), src: frameURL, onLoad: onLoad }, void 0)) : serverStatus.reason ? (jsx(PluginErrorBoundary, { style: iframeStyle, reason: serverStatus.reason, onRetry: handleRetry }, void 0)) : (jsx("div", { style: iframeStyle }, void 0));
    }, [iframeClass, iframeStyle, serverStatus, handleRetry]);
    return PluginLoadingWrapper(loading, moduleKey, children);
};

var Component = function (_a, ref) {
    var url = _a.url, moduleKey = _a.moduleKey, qiankunGlobalStateChange = _a.qiankunGlobalStateChange, qiankunProps = _a.qiankunProps, qiankunStyle = _a.qiankunStyle, qiankunClass = _a.qiankunClass;
    var _b = __read(useState(true), 2), loading = _b[0], setLoading = _b[1];
    var qiankunContainerRef = useRef(null);
    var actionRef = useRef(null);
    var _c = __read(useState({
        error: true,
        reason: null,
    }), 2), serverStatus = _c[0], setServerStatus = _c[1];
    var _d = usePluginGlobalConfig(), globalInitProps = _d.globalInitProps, PluginErrorBoundary = _d.pluginErrorBoundary, PluginLoadingWrapper = _d.pluginLoadingWrapper, axios = _d.axiosInstance;
    var server = useServerSDK();
    var startLoadPlugin = useCallback(function () { return __awaiter(void 0, void 0, void 0, function () {
        var e_1, status_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setLoading(true);
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, axios.get(url)];
                case 2:
                    _a.sent();
                    setServerStatus({
                        error: false,
                        reason: null,
                    });
                    return [3 /*break*/, 4];
                case 3:
                    e_1 = _a.sent();
                    if (!e_1.response) {
                        setServerStatus({
                            error: true,
                            reason: "NONE",
                        });
                    }
                    else {
                        status_1 = e_1.response.status;
                        setServerStatus({
                            error: true,
                            reason: status_1,
                        });
                    }
                    setLoading(false);
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    }); }, [axios, url]);
    // 用于同一个页面切换插件时，loading初始化
    useEffect(function () {
        startLoadPlugin();
    }, [startLoadPlugin]);
    useEffect(function () {
        var app;
        if (!serverStatus.error) {
            var loadMicroApp_1 = require("qiankun").loadMicroApp;
            var route_1 = url.split("#")[1]; // hash子路由传给子应用，用于子应用默认跳转的地址
            var registerPlugin = function () { return __awaiter(void 0, void 0, void 0, function () {
                var proximaSDK, ProximaSDK;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(typeof window !== "undefined")) return [3 /*break*/, 2];
                            ProximaSDK = require("@projectproxima/plugin-sdk").ProximaSDK;
                            proximaSDK = new ProximaSDK({ sdkServer: server });
                            return [4 /*yield*/, server.register({
                                    type: "micro",
                                    module: moduleKey,
                                    instance: proximaSDK,
                                    frame: qiankunProps.frame,
                                    context: qiankunProps.context || {},
                                })];
                        case 1:
                            _a.sent();
                            return [2 /*return*/, proximaSDK];
                        case 2: return [2 /*return*/];
                    }
                });
            }); };
            registerPlugin().then(function (sdk) {
                var _a;
                var initProps = __assign(__assign({}, globalInitProps), { route: route_1, sdk: sdk });
                if (sdk) {
                    app = loadMicroApp_1({
                        name: "app_" + Date.now(),
                        entry: url,
                        container: qiankunContainerRef.current,
                        props: qiankunProps ? __assign(__assign({}, initProps), qiankunProps) : initProps,
                    });
                    (_a = app === null || app === void 0 ? void 0 : app.mountPromise) === null || _a === void 0 ? void 0 : _a.then(function () {
                        setLoading(false);
                    }).catch(function () {
                        setServerStatus({
                            error: true,
                            reason: "NONE",
                        });
                        setLoading(false);
                    });
                }
            });
        }
        return function () {
            if (app) {
                server.unRegister(moduleKey, qiankunProps.frame.key);
                app === null || app === void 0 ? void 0 : app.unmount();
            }
        };
    }, [moduleKey, server, url, qiankunProps, serverStatus, globalInitProps]);
    useEffect(function () {
        var _a;
        var initGlobalState = require("qiankun").initGlobalState;
        // 初始化 globalstate
        actionRef.current = initGlobalState({ data: null });
        if (qiankunGlobalStateChange) {
            (_a = actionRef.current) === null || _a === void 0 ? void 0 : _a.onGlobalStateChange(qiankunGlobalStateChange);
        }
        return function () {
            var _a;
            (_a = actionRef.current) === null || _a === void 0 ? void 0 : _a.offGlobalStateChange();
        };
    }, [qiankunGlobalStateChange]);
    useImperativeHandle(ref, function () { return ({
        setGlobalState: function (data) {
            var _a;
            (_a = actionRef.current) === null || _a === void 0 ? void 0 : _a.setGlobalState({ data: data });
        },
    }); });
    var style = useMemo(function () {
        return __assign(__assign({}, qiankunStyle), { minHeight: "auto" });
    }, [qiankunStyle]);
    var handleRetry = useCallback(function () {
        startLoadPlugin();
    }, [startLoadPlugin]);
    var children = useMemo(function () {
        return (jsx(Fragment, { children: !serverStatus.error ? (jsx("div", { ref: qiankunContainerRef, style: style, className: qiankunClass }, void 0)) : serverStatus.reason ? (jsx(PluginErrorBoundary, { style: style, reason: serverStatus.reason, onRetry: handleRetry }, void 0)) : (jsx("div", { style: style }, void 0)) }, void 0));
    }, [style, qiankunClass, serverStatus, handleRetry]);
    return PluginLoadingWrapper(loading, moduleKey, children);
};
var QiankunComponent = forwardRef(Component);

var RemoteComponentErrorBoundary = /** @class */ (function (_super) {
    __extends(RemoteComponentErrorBoundary, _super);
    function RemoteComponentErrorBoundary(props) {
        var _this = _super.call(this, props) || this;
        _this.state = { hasError: false };
        return _this;
    }
    RemoteComponentErrorBoundary.getDerivedStateFromError = function () {
        return { hasError: true };
    };
    RemoteComponentErrorBoundary.prototype.render = function () {
        if (this.state.hasError) {
            return (jsx("span", __assign({ style: { background: "red", color: "#fff", fontSize: "16px" } }, { children: this.props.errorText || "插件数据有误" }), void 0));
        }
        return this.props.children;
    };
    return RemoteComponentErrorBoundary;
}(Component$1));
var loadRemoteComponentFactory = function (getModule) {
    return function (name, contextProps) {
        return loadRemoteComponent(name, getModule, contextProps);
    };
};
var loadRemoteComponent = function (name, getModule, contextProps) { return __awaiter(void 0, void 0, void 0, function () {
    var scriptText, modules, fn, exports;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, axios.get(name)];
            case 1:
                scriptText = (_a.sent()).data;
                modules = {
                    exports: {
                        default: null,
                    },
                };
                fn = new Function("module", "require", "contextProps", scriptText);
                fn(modules, getModule, contextProps);
                exports = modules.exports;
                return [2 /*return*/, Object.getOwnPropertyNames(exports).reduce(function (prev, current) {
                        var _a;
                        return __assign(__assign({}, prev), (_a = {}, _a[current] = function (props) { return (jsx(RemoteComponentErrorBoundary, __assign({ errorText: "\u63D2\u4EF6\u52A0\u8F7D\u5931\u8D25" }, { children: exports[current](props) }), void 0)); }, _a));
                    }, {})];
        }
    });
}); };

var useRemoteComponent = function (remoteUrl, propsResult) {
    var _a = __read(useState(true), 2), loading = _a[0], setLoading = _a[1];
    var _b = __read(useState(), 2), componentModule = _b[0], setComponentModule = _b[1];
    var remoteComponentGetDependencies = usePluginGlobalConfig().remoteComponentGetDependencies;
    var loadRemote = useMemo(function () {
        return loadRemoteComponentFactory(remoteComponentGetDependencies);
    }, [remoteComponentGetDependencies]);
    useEffect(function () {
        loadRemote(remoteUrl, propsResult).then(function (module) {
            setComponentModule(module);
            setLoading(false);
        });
    }, [loadRemote, remoteUrl, propsResult]);
    return {
        componentModule: componentModule,
        loading: loading,
    };
};
var RemoteComponent = function (_a) {
    var url = _a.url, moduleKey = _a.moduleKey, contextProps = _a.contextProps;
    var _b = __read(useState(null), 2), propsResult = _b[0], setPropsResult = _b[1];
    var _c = useRemoteComponent(url, propsResult), componentModule = _c.componentModule, remoteLoading = _c.loading;
    var server = useServerSDK();
    var globalInitProps = usePluginGlobalConfig().globalInitProps;
    useEffect(function () {
        if (propsResult) {
            return;
        }
        var proximaSDK;
        var registerPlugin = function () { return __awaiter(void 0, void 0, void 0, function () {
            var ProximaSDK;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(typeof window !== "undefined")) return [3 /*break*/, 2];
                        ProximaSDK = require("@projectproxima/plugin-sdk").ProximaSDK;
                        proximaSDK = new ProximaSDK({ sdkServer: server });
                        return [4 /*yield*/, server.register({
                                type: "remote",
                                module: moduleKey,
                                instance: proximaSDK,
                                frame: contextProps.frame,
                                context: contextProps.context || {},
                            })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, proximaSDK];
                    case 2: return [2 /*return*/];
                }
            });
        }); };
        registerPlugin().then(function (sdk) {
            var initProps = __assign(__assign({}, globalInitProps), { sdk: sdk });
            if (sdk) {
                setPropsResult(contextProps ? __assign(__assign({}, initProps), contextProps) : initProps);
            }
        });
        return function () {
            if (proximaSDK) {
                server.unRegister(moduleKey, contextProps.frame.key);
            }
        };
    }, [propsResult, globalInitProps, server, contextProps, moduleKey]);
    if (remoteLoading || !propsResult)
        return jsx("p", { children: "loading..." }, void 0);
    var Comp = componentModule === null || componentModule === void 0 ? void 0 : componentModule[moduleKey];
    return Comp ? jsx(Comp, __assign({}, propsResult), void 0) : null;
};

export { CustomIframe, PluginGlobalConfigContext, QiankunComponent, RemoteComponent, RemoteComponentErrorBoundary, loadRemoteComponent, loadRemoteComponentFactory, usePluginGlobalConfig };
//# sourceMappingURL=bundle.esm.js.map
